<?php
namespace Zeedhi\Report\ReportStrategy;

use \Zeedhi\Report\LogoConfig;

class HTML implements \BuiltReportStrategy{

    private $assetsPath;

    public function __construct(array $reportMetadata, array $reportData, LogoConfig $logoConfig, $templatePath, $cachePath, $targetFile, $assetsPath, $templateName){
        $this->reportMetadata = $reportMetadata;
        $this->reportData = $reportData;
        $this->logoConfig = $logoConfig;
        $this->templatePath = $templatePath;
        $this->cachePath = $cachePath;
        $this->targetFile = $targetFile;
        $this->assetsPath = $assetsPath;
        $this->templateName = $templateName;
    }

    public function build(){
        $template = $this->createTemplateEngine();
        $html = $template->render(array(
            'assetsPath' => $this->assetsPath,
            'metadata' => json_encode($this->reportMetadata),
            'data' => json_encode($this->reportData),
            'logo' => json_encode($this->logoConfig->jsonSerialize())
        ));
        file_put_contents($this->targetFile, $html);
    }
    public function formatName(){
        return "html";
    }

    protected function createTemplateEngine() {
        \Twig_Autoloader::register();
        $loader = new \Twig_Loader_Filesystem($this->templatePath);
        $twig   = new \Twig_Environment($loader, array(/*'cache' => $this->getCachePath() */));
        $twig->addGlobal('formatterApplier', new \Zeedhi\Report\Formatters\FormatterApplier());
        $template = $twig->loadTemplate($this->templateName);
        return $template;
    }

}